function batch_Digits_inseen
close all;
dbstop if error;

load Digits_Data

[num_ex,num_labels] = size(True_Y);

for i = 1:num_labels
    ind_data(i).labels = find(True_Y(:,i) == 1);
end


% %plot the digit data
% ex_dig = 256 * ((reshape(Data_X(ind_data(1).labels(1),:),16,16))' + 1)/2;
% figure;image(ex_dig);
% ex_dig = 256 * ((reshape(Data_X(ind_data(2).labels(1),:),16,16))' + 1)/2;
% figure;image(ex_dig);



lrn_par = Set_Default_Learning_Paramters;

% distance paramters
lrn_par.DST_TYPE = 1; % 1 for Euclidean, 2 for dot

% Optimization for both ALPHA and SIGMA together
lrn_par.OPT_S_A = 0; % set to 1 to optimize for both alpha and sigma
lrn_par.Cluster_Search = [3,4,5]; % This defines the clusters to be evaluated



%Clustering Example
model_cluster = LG_Cluster(Data_X,lrn_par);

fprintf(1,'Now unseen....\n');

load Digits_Data_us

[un_class] = Classify_New_Data(Data_X_us,model_cluster);
t10000 = 5;

save temp;


model = model_cluster;
% plot class outliers outliers
for i = 1:num_labels
    for j = 1:3
        ex_dig = 256 * ((reshape(Data_X(model.Class_Outlier(i).ind_sort(j),:),16,16))' + 1)/2;
        figure;image(ex_dig); title('Class outlier');
        t77 = 77;
    end
    t77 = 0;
end


% plot bigist overall outliers
for i = 1:10
    ex_dig = 256 * ((reshape(Data_X(model.ind_sort_mean_dist(i),:),16,16))' + 1)/2;
    figure;image(ex_dig); title('Worst overall outliers');
    t77 = 77;
end

error_thing(True_Y_us,un_class.Y)

t10000 = 5;






function error_thing(True_Y,Y)
    tab=crosstab(True_Y*(1:4)',Y*(1:4)');
    xmax=max(tab);
    dcount=1;
    for i=1:length(xmax) 
        xx=find(tab(:,i)==xmax(i));
        if length(xx)>1
            myperm(i)=xx(dcount);
            dcount=dcount+1;
        else
            myperm(i)=xx(1);
        end;
    end;
    for i=1:length(myperm)
        xx=find(myperm==i);
        if length(xx)<1
            xmyperm(i)=1;
        else
            xmyperm(i)=xx(1);
        end;
    end;
    %myperm=xmyperm;
    tab=[tab(:,xmyperm), tab]

    True_Y=True_Y(:,myperm);
    
    errors = abs(Y - True_Y);
    err_ind = find(sum(abs(Y - True_Y)')'>0);
    num_errors = length(err_ind);
    err_rate = num_errors / length(True_Y)
return;


